/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ImageEngine.hpp"

ImageEngine *ImageEngine::singletonObject = 0;

ImageEngine::ImageEngine()
{
    
}

ImageEngine *ImageEngine::getInstance()
{
    if (!singletonObject)
        singletonObject = new ImageEngine();
    
    return singletonObject;
}

sf::Image *ImageEngine::getImage(const std::string &imagePath)
{
    if (!isImageLoaded(imagePath))
        loadImage(imagePath);
    
    return m_imagesList[imagePath];
}

void ImageEngine::loadImage(const std::string &imagePath)
{   
    sf::Image *loadedImage = new sf::Image();
    loadedImage->LoadFromFile(imagePath);
    loadedImage->SetSmooth(false);
    
    m_imagesList[imagePath] = loadedImage;
}

bool ImageEngine::isImageLoaded(const std::string &imagePath)
{
    std::map<std::string, sf::Image*>::iterator it;
    it = m_imagesList.find(imagePath);
    
    if (it != m_imagesList.end())
        return true;
    
    return false;
}